import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class Tetv3_gui extends Frame
{
	public Tetv3_gui()
	{
		setLayout(new BorderLayout());
		Panel n = new Panel();
		Panel c = new Panel();

		add("North",n);
		add("Center",c);
		n.setBackground(Color.gray);
		c.setBackground(Color.lightGray);

		button1 = new Button();
		button1.setLabel("Run TCC");
		button1.setEnabled(false);
		button1.setBackground(Color.red);
		n.add(button1);
		checkbox1 = new Checkbox();
		checkbox1.setLabel("Build");
		n.add(checkbox1);
		checkbox2 = new Checkbox();
		checkbox2.setLabel("Execute");
		n.add(checkbox2);
		checkbox3 = new Checkbox();
		checkbox3.setLabel("Clean");
		n.add(checkbox3);
		textField1 = new TextField(4);
		textField1.setBackground(Color.white);
		n.add(textField1);
		labelT = new Label("Timeout");
		n.add(labelT);
		buttonCAO = new Button();
		buttonCAO.setLabel("Clear Advanced Options");
		n.add(buttonCAO);

		Panel c1 = new Panel();
		c1.setLayout(new GridLayout(3,1));
		c1.setBackground(Color.white);
		c.add(c1);
		Panel c2 = new Panel();
		c2.setLayout(new BorderLayout());
		c.add(c2);

		Panel c11 = new Panel();
		c11.setLayout(new FlowLayout(FlowLayout.RIGHT));
		Panel c12 = new Panel();
		c12.setLayout(new FlowLayout(FlowLayout.RIGHT));
		Panel c13 = new Panel();
		c13.setLayout(new FlowLayout(FlowLayout.RIGHT));
		c1.add(c11);
		c1.add(c12);
		c1.add(c13);

		Panel c21 = new Panel();
		c21.setLayout(new FlowLayout(FlowLayout.RIGHT));
		Panel c22 = new Panel();
		c22.setLayout(new BorderLayout());
		c2.add("Center",c21);
		c2.add("South",c22);
		Panel wc22 = new Panel();
		wc22.setLayout(new GridLayout(6,1));
		c22.add("West", wc22);
		Panel cc22 = new Panel();
		c22.add("Center",cc22);

		buttonOTS = new Button();
		buttonOTS.setLabel("Open Test Suite");
		c11.add(buttonOTS);
		textFieldTS = new TextField(60);
		textFieldTS.setEditable(false);
		c11.add(textFieldTS);

		c12.add(new Label("Scenario file"));
		textFieldSF = new TextField(60);
		textFieldSF.setEditable(false);
		c12.add(textFieldSF);

		c13.add(new Label("Scenario"));
		textFieldS = new TextField(60);
		c13.add(textFieldS);
				

		labelin = new Label("Stdin     ");
		c21.add(labelin);
		textField2 = new TextField(cmd,70);
		textField2.setEditable(false);
		c21.add(textField2);
		labelout = new Label("Stdout/err");
		wc22.add(labelout);
		buttonC = new Button();
		buttonC.setLabel("Clear");
		wc22.add(buttonC);
		buttonVJ = new Button();
		buttonVJ.setLabel("View Journal");
		buttonVJ.setEnabled(false);
		wc22.add(buttonVJ);
		textArea1 = new TextArea(7,70);
		textArea1.setEditable(false);
		cc22.add(textArea1);

		setTitle(title);
		setResizable(false);
//File menu
		mainMenuBar = new MenuBar();
		menu1 = new Menu("File");
		miOpen = new MenuItem("Open Test Suite", new MenuShortcut(KeyEvent.VK_O));
		miOpen.setEnabled(true);
		menu1.add(miOpen);
		miClose = new MenuItem("Close Test Suite");
		miClose.setEnabled(false);
		menu1.add(miClose);
		menu1.addSeparator();
		miExit = new MenuItem("Exit");
		menu1.add(miExit);
		mainMenuBar.add(menu1);
//Edit menu
		menu2 = new Menu("Edit");
		miOpenPad = new MenuItem("Open File Editor");
		menu2.add(miOpenPad);
		menu2.addSeparator();
		miViewRJF = new MenuItem("View Raw Journal File", new MenuShortcut(KeyEvent.VK_R));
		menu2.add(miViewRJF);
		miViewJF = new MenuItem("View Formatted Journal File", new MenuShortcut(KeyEvent.VK_F));
		menu2.add(miViewJF);
		miCompare = new MenuItem("Compare Test Results", new MenuShortcut(KeyEvent.VK_C));
		menu2.add(miCompare);
		mainMenuBar.add(menu2);
//Options menu
		menu3 = new Menu("Options");
		miRun = new MenuItem("Run TCC", new MenuShortcut(KeyEvent.VK_X));
		miRun.setEnabled(false);
		menu3.add(miRun);
		menu3.addSeparator();
		miAdvOptions = new MenuItem("Advanced Options", new MenuShortcut(KeyEvent.VK_A));
		menu3.add(miAdvOptions);
		miProgRep = new CheckboxMenuItem("Progress Reporting", true);
		menu3.add(miProgRep);
		mainMenuBar.add(menu3);
//Help menu
		menu4 = new Menu("Help");
		mainMenuBar.setHelpMenu(menu4);
		miTetHelp = new MenuItem("TETware Help", new MenuShortcut(KeyEvent.VK_F1));
		menu4.add(miTetHelp);
		menu4.addSeparator();
		miAbout = new MenuItem("About");
		menu4.add(miAbout);
		mainMenuBar.add(menu4);

		setMenuBar(mainMenuBar);
		Image icon = getImage("atlantis.gif");
		setIconImage(icon);


	}

//---------Main--------------------------------------------------------------------------

	static public void main(String args[])
	throws IOException
	{
		Tetv3_gui t = new Tetv3_gui();
		System.out.println(t.getTetRoot());
		Frame f = new Tetv3_gui();
		f.resize(640,400);
		f.show();

	}

//---------Show--------------------------------------------------------------------------

	public void show()
	{
		try
		{
			FileInputStream fis = new FileInputStream("TSop");
			DataInputStream dis = new DataInputStream(fis);
			String TSop = dis.readLine();
			fis.close();
			System.out.println(TSop + " is TSop in show");
			testSuite = sortTSopString(testSuite, "-ts ", TSop);
			scenarioFile = sortTSopString(scenarioFile, "-sf ", TSop);
			scenario = sortTSopString(scenario, "-ss ", TSop);
			textFieldTS.setText(testSuite);
			textFieldSF.setText(scenarioFile);
			textFieldS.setText(scenario);
			if(testSuite.compareTo("")>0)
			{
				this.setTitle(this.getTitle() + "[" + testSuite + scenarioFile + "]");
				miOpen.setEnabled(false);
				miClose.setEnabled(true);
				buttonOTS.setLabel("Close Test Suite");
			}
		}
		catch(IOException e)
		{
			System.out.println("Problem loading file " + e);
		}
		super.show();
	}

//---------Close application-------------------------------------------------------------

	public boolean handleEvent(Event evt)
	{
		if(evt.id == Event.WINDOW_DESTROY)
		{
			ExitDialog ex = new ExitDialog(this);
			ex.show();
		}
		return super.handleEvent(evt);
	}


//---------Compnent Events --------------------------------------------------------------

	public boolean action(Event evt, Object arg)
	{
		Process proc;
		BufferedReader is;
		BufferedReader es;

		if(arg.equals("Open Test Suite"))
		{

			FileDialog od = new FileDialog(this, "Open test suite", FileDialog.LOAD);
			try
			{		
				String tet_root = getTetRoot();
				od.setDirectory(tet_root);
				od.show();
				textArea1.setText("");
				if(od.getFile()!=null)
				{
					scenarioFile = od.getFile();
					testSuite = od.getDirectory();
				}else{
					scenarioFile = "";
					testSuite = "";
					return true;
				}					
			System.out.println(scenarioFile);
			System.out.println(testSuite);

				if(scenarioFile.compareTo("tet_scen")!=0)
				{
					System.out.println(scenarioFile + " is not the default scenario file");
					AlternateScenarioDialog as = new AlternateScenarioDialog(this);
					as.show();
					if(setFile == false)	//if the wrong scenario file is chosen
						return true;	//do not open
				}

					textFieldSF.setText(scenarioFile);
					if(testSuite.compareTo(tet_root)==0)
						textFieldTS.setText("");
					else
						textFieldTS.setText(testSuite);
			}
			catch(IOException e)
			{
				System.err.println(e);
			}

			
			this.setTitle(this.getTitle() + "[" + testSuite + scenarioFile + "]");
			miOpen.setEnabled(false);
			miClose.setEnabled(true);
			buttonOTS.setLabel("Close Test Suite");

		}

		if(arg.equals("Close Test Suite"))
		{
			try
			{
				FileOutputStream fos = new FileOutputStream("ScenF");
				PrintStream ps = new PrintStream(fos);
				ps.print(" ");
				fos.close();
			}
			catch(IOException e)
			{
				System.out.println("Problem " + e);
			}
			scenarioFile = "";
			testSuite = "";
			scenario = "";
			cmd = "tcc ";
			textField2.setText(cmd);			
			this.setTitle(title);
			miOpen.setEnabled(true);
			miClose.setEnabled(false);
			buttonOTS.setLabel("Open Test Suite");	
			textFieldTS.setText("");		
			textFieldSF.setText("");
			textFieldS.setText("");
			cb1Flag=cb2Flag=cb3Flag=false;
			checkbox1.setState(false);
			checkbox2.setState(false);
			checkbox3.setState(false);
			runStatus(button1);			//check status of tcc button
			runStatus(miRun);			//check status of tcc menu item

		}

		if(arg.equals("Open File Editor"))
		{
			try
			{
				System.out.println("Opening JavaPad");
				Runtime.getRuntime().exec("java JavaPad");
			}
			catch(IOException e)
			{
				System.err.println("No such command " + e);
				return true;
			}
		}			

		if(arg.equals("View Raw Journal File"))
		{
			FileDialog od = new FileDialog(this, "Open...", FileDialog.LOAD);
			od.show();
			if(od.getFile()!=null)
			{
				String tmp;
				osys = System.getProperty("os.name");
				try
				{
					Process jpad;
					System.out.println(osys);
					if(osys.compareTo("Windows 95") == 0 || osys.compareTo("Windows NT") == 0)
						tmp = "java JavaPad " + "\"" + od.getDirectory() + od.getFile() + "\"";
					else
						tmp = "java JavaPad " + od.getDirectory() + od.getFile();
					System.out.println(tmp);
					jpad = Runtime.getRuntime().exec(tmp);
				}
				catch(IOException e)
				{
					System.out.println("Problem opening JavaPad " + e);
				}
			}
			od.dispose();
		}

		if(arg.equals("View Formatted Journal File"))
		{
			ViewJFDialog vjfd = new ViewJFDialog(this);
			vjfd.show();
		}

		if(arg.equals("Compare Test Results"))
		{
			CompareResultsDialog crd = new CompareResultsDialog(this);
			crd.show();
		}

		if(arg.equals("About"))
		{
			AboutDialog ab = new AboutDialog(this);
			ab.show();
		}

		if(arg.equals("TETware Help"))
		{
			HelpDialog hd = new HelpDialog(this);
			hd.show();
		}

		if(arg.equals("Clear"))
		{
			buttonVJ.setEnabled(false);
			textArea1.setText("");
		}

		if(arg.equals("View Journal"))
		{
			String text = textArea1.getText();
			int txI = text.lastIndexOf("tcc: journal");
			text = text.substring(txI + 21);
			text = text.substring(0, text.indexOf("\n"));
			System.out.println(text + " is text ");
			String tmp;
			osys = System.getProperty("os.name");
			try{
				if(osys.compareTo("Windows 95") == 0 || osys.compareTo("Windows NT") == 0)
					tmp = "java JavaPad " + "\"" + text + "\"";
				else
					tmp = "java JavaPad " + text;
				System.out.println(tmp + " is tmp");
				Process jpad = Runtime.getRuntime().exec(tmp);
			}catch(IOException e){
				System.out.println("Problems executing javapad " + e);
			}
		}

		if(arg.equals("Exit"))
		{
			ExitDialog ex = new ExitDialog(this);
			ex.show();
		}

		if(arg.equals("Advanced Options"))
		{
			AdvOptions aop = new AdvOptions(this);
			aop.show();	
		}

		if(evt.target instanceof Checkbox)
		{
			System.out.println("Chkbx flipped\n");
			System.out.println(checkbox1.getState() + "\n");

			if(checkbox1.getState() != cb1Flag)			//if cb1 changes state
			{
				if(checkbox1.getState())			//if cb1 is checked
				{
					addToPath("-b");
					cb1Flag = true;				//cb1 is checked=>true
					runStatus(button1);			//check status of tcc button
					runStatus(miRun);			//check status of tcc menu item
					return true;
				}else{						//else cb1 is no longer checked	

					removeFromPath("-b");
					cb1Flag = false;			//cb1 is not checked=>false
					runStatus(button1);			//check status of tcc button
					runStatus(miRun);			//check status of tcc menu item
					return true;
				}
			}
			if(checkbox2.getState() != cb2Flag)			//if cb2 changes state		
			{
				if(checkbox2.getState())			//if cb2 is checked
				{
					addToPath("-e");
					cb2Flag = true;				//cb2 is checked=>true		
					runStatus(button1);			//check status of tcc button
					runStatus(miRun);			//check status of tcc menu item
					return true;
				}else{						//else cb2 is no longer checked	
					removeFromPath("-e");
					cb2Flag = false;			//cb2 is not checked=>false
					runStatus(button1);			//check status of tcc button
					runStatus(miRun);			//check status of tcc menu item
					return true;
				}
			}
			if(checkbox3.getState() != cb3Flag)			//if cb3 changes state
			{	
				if(checkbox3.getState())			//if cb3 is checked
				{			
					addToPath("-c");	
					cb3Flag = true;				//cb3 is checked=>true
					runStatus(button1);			//check status of tcc button
					runStatus(miRun);			//check status of tcc menu item
					return true;
				}else{						//else cb3 is no longer checked	
					removeFromPath("-c");
					cb3Flag = false;			//cb3 is not checked=>false
					runStatus(button1);			//check status of tcc button
					runStatus(miRun);			//check status of tcc menu item
					return true;
				}
			}

			return true;
		}		

		if(arg.equals("Clear Advanced Options"))
		{
			try
			{
				FileOutputStream fos = new FileOutputStream("AdvOp");
				PrintStream ps = new PrintStream(fos);
				ps.print("\n");
				fos.close();
			}
			catch(IOException e)
			{
				System.out.println("Problems writing to file AdvOp");
			}
		}

		if(arg.equals("Run TCC"))						//if "Run TCC" pressed
		{
			advop = "";
			advop = setAdvOp();
			System.out.println(advop + " are the adv ops in run");
			System.out.println(strOJF + "is strOJF");

			if(scenarioFile.compareTo("")==0)
			{
				NoTSuiteDialog nts = new NoTSuiteDialog(this);
				nts.show();
				return true;
			}

			try
			{
				String timeout = " ";
				if(textField1.getText().compareTo("")>0)
				{
					try
					{
						Integer tmp = new Integer(textField1.getText());
						int time = tmp.intValue();
						System.out.println("The timeout value is " + time);
						timeout = " -t " + time + " ";
					}
					catch(NumberFormatException e)
					{
						System.out.println("Timeout value must be a number" + e);
						textArea1.append("Timeout value must be a number" + e + "\n");
						TimeoutDialog to = new TimeoutDialog(this);
						to.show();
						return true;
					}
				}

				try
				{
					String tr = getTetRoot();
					System.out.println(tr + " is tetroot");
					System.out.println(testSuite.substring(0,tr.length()) + " testsuitedir");
					testSuite = testSuite.toLowerCase();
					if(tr.compareTo(testSuite.substring(0,tr.length()))==0)
						testSuite = testSuite.substring(tr.length() + 1);
				}
				catch(RuntimeException e)
				{
					System.out.println("Test suite is in a different directory to TET_ROOT");
				}

				scenario = " " + textFieldS.getText();

				if(miProgRep.getState() == true)
				{
					args = advop + " -p " + timeout + strOJF + testSuite + scenario;
				}else{
					args = advop + timeout + strOJF + testSuite + scenario;
				}

				System.out.println(args);
				cmd += " " + args;
				textField2.setText(cmd);

				try{
					proc = Runtime.getRuntime().exec(cmd);
					is = new BufferedReader(new InputStreamReader(proc.getInputStream()));
					for(String nextline=is.readLine(); nextline != null; nextline = is.readLine())
					{
						System.out.println(nextline);
						nextline+="\n";
						textArea1.append(nextline);
					}
					es = new BufferedReader(new InputStreamReader(proc.getErrorStream()));
					for(String nextline2=es.readLine(); nextline2 != null; nextline2 = es.readLine())
					{
						System.out.println(nextline2);
						nextline2+="\n";
						textArea1.append(nextline2);
						ExceptionDialog ed = new ExceptionDialog(this);
						ed.show();
						cmd = delflag(args , cmd);
					//	textField2.setText(cmd);
						strM = strR = strS = strJ = 
						strG = strX = strF = strA = 
						strI = strL = strN = strY = strV = "";

						return true;
					}
					buttonVJ.setEnabled(true);

				}catch(IOException e){

					System.err.println("No such command " + e);
					return true;
				}
				cmd = delflag(args , cmd);
			//	textField2.setText(cmd);
				System.out.println("this is the cmd " + cmd);

			}
			catch(IOException e){
			} 

		}

		else return super.action(evt,arg);
		return true;
	}

//---------Sort the string from the TSop file--------------------------------------------

	public String sortTSopString(String str, String option, String tsop)
	{
		int opI, xxI, tmp;

		try
		{
			tmp = tsop.indexOf(option);
			if(tmp >= 0)
			{
				opI = tmp;
			}else{
				opI = -1;
				str = "";
			}
		}
		catch(RuntimeException e)
		{
			opI = -1;
			str = "";
		}

		if(opI != -1)
		{
			String temp = tsop.substring(opI);
			xxI = temp.indexOf("**");
			str = temp.substring(3, xxI).trim();
		}
		return str;
	}


//---------Set the advanced options string-----------------------------------------------

	public String setAdvOp()
	{
		try
		{
			FileInputStream fis = new FileInputStream("AdvOp");
			DataInputStream dis = new DataInputStream(fis);
			advop = dis.readLine();
			fis.close();

			strOJF = sortString(strOJF, "-oj ");
			strM = sortString(strM, "-m ");
			strR = sortString(strR, "-r ");
			strJ = sortString(strJ, "-j ");
			strG = sortString(strG, "-g ");
			strX = sortString(strX, "-x ");
			strF = sortString(strF, "-f ");
			strA = sortString(strA, "-a ");
			strI = sortString(strI, "-i ");
			strL = multipleOption(strL, "-l ");
			strN = multipleOption(strN, "-n ");
			strY = multipleOption(strY, "-y ");
			strV = multipleOption(strV, "-v ");

			FileInputStream fis2 = new FileInputStream("ScenF");
			DataInputStream dis2 = new DataInputStream(fis2);
			strS = dis2.readLine();
			fis2.close();

			strS = sortString(strS, "-s ", strS);

			advop = strM + strR + strS + strJ + 
				strG + strX + strF + strA + 
				strI + strL + strN + strY + strV;
		}
		catch(IOException e)
		{
			System.out.println("Problems reading file " + e );
		}
		return advop;
	}

//---------Sort the advanced option string-----------------------------------------------

	public String sortString(String str, String option)
	{
		int opI, xxI, tmp;
		String stateSet;

		try
		{
			tmp = advop.indexOf(option);
			if(tmp >= 0)
			{
				opI = tmp;
			}else{
				opI = -1;
				str = "";
				stateSet = "";
			}
		}
		catch(RuntimeException e)
		{
			opI = -1;
			stateSet = "";
			str = "";
		}

		if(opI != -1)
		{
			String temp = advop.substring(opI);
			xxI = temp.indexOf("**");
			stateSet = temp.substring(xxI, xxI+3);
			if(stateSet.compareTo("**!")==0)
				if(option.compareTo("-oj ")==0)
					str = " " + temp.substring(3, xxI);
				else
					str = " " + option + temp.substring(3, xxI);
			else
				str = "";
		}
		return str;
	}

	public String sortString(String str, String option, String advOpt)
	{
		int opI, xxI, tmp;
		String stateSet;

		try
		{
			tmp = advOpt.indexOf(option);
			if(tmp >= 0)
			{
				opI = tmp;
			}else{
				opI = -1;
				str = "";
				stateSet = "";
			}
		}
		catch(RuntimeException e)
		{
			opI = -1;
			str = "";
			stateSet = "";
		}

		if(opI != -1)
		{
			String temp = advOpt.substring(opI);
			xxI = temp.indexOf("**");
			stateSet = temp.substring(xxI, xxI+3);
			if(stateSet.compareTo("**!")==0)
				str = " " + option + temp.substring(3, xxI).trim();
			else
				str = "";
		}
		return str;
	}

//---------count the no of rows in textarea options--------------------------------------

	public int noOfRows(String option)		//used for advop text areas
	{
		String tmp = advop;
		int count = 0;
		int opI = tmp.indexOf(option);
		while(opI != -1)
		{
			count++;
			tmp = tmp.substring(opI + 3);
			opI = tmp.indexOf(option);
		}
		return count;
	}

	public String multipleOption(String str, String option)
	{
		String temp = advop;
		for(int nor=0; nor < noOfRows(option); nor++)
		{
			str += sortString(str, option, temp);
			temp = temp.substring(temp.indexOf(option) + 3);
		}
		return str;
	}

//---------Remove flag from String command-----------------------------------------------

	public String delflag(String flag, String cmd)
	{
		System.out.println("Removing " + flag + "\n");
		int fl = flag.length();
		int i = cmd.indexOf(flag);
		cmd = cmd.substring(0,i-1)+cmd.substring(i+fl,cmd.length());
		return cmd;
	}

//---------Set status of Run-tcc (overloaded method)-------------------------------------

	public boolean runStatus(Component c)
	{
		if((cb1Flag == false) && (cb2Flag == false) && (cb3Flag == false))	//if all bec checkboxes are false
		{
			c.setEnabled(false);						//disable Run-tcc component
			c.setBackground(Color.red);
			System.out.println("Component disabled\n");
			return false;
		}else{									//else at least one bec checkbox is true
			c.setEnabled(true);						//enable Run-tcc component
			c.setBackground(Color.green);	
			System.out.println("Component enabled\n");			
			return true;
		}
	}

	public boolean runStatus(MenuItem m)
	{
		if((cb1Flag == false) && (cb2Flag == false) && (cb3Flag == false))
		{
			m.setEnabled(false);
			System.out.println("Component disabled\n");
			return false;
		}else{
			m.setEnabled(true);
			System.out.println("Component enabled\n");
			return true;
		}
	}
//---------Add/Remove option to/from path------------------------------------------------


	public void addToPath(String option)
	{
		cmd += " " + option;			//add option to path
		textField2.setText(cmd);		//write current command to text field	
		System.out.println(cmd + "true");	//(debug line)
	}


	public void removeFromPath(String option)
	{
		cmd = delflag(option , cmd);		//remove option from path
		textField2.setText(cmd);		//write current command to text field	
		System.out.println(cmd + " false");	//(debug line)
	}


//---------Get the TETware root directory------------------------------------------------

	public String getTetRoot()
	throws IOException
	{
		String tet_root = null;
	        osys = System.getProperty("os.name");
		if(osys.compareTo("Windows 95") == 0 || osys.compareTo("Windows NT") == 0)
		{
			RandomAccessFile raf = new RandomAccessFile("gtcc.vars","r");
			for(String nextLine = raf.readLine(); nextLine!=null; nextLine = raf.readLine())
			{
				if(nextLine.startsWith("SET TET_ROOT"))
				{
					int i = nextLine.indexOf("=");
					tet_root = nextLine.substring(i+1);
					int j = tet_root.length();
					tet_root = tet_root.substring(0,j-2);
				}
			}
		}else{
			RandomAccessFile raf = new RandomAccessFile("gtcc.vars","r");
			for(String nextLine = raf.readLine(); nextLine!=null; nextLine = raf.readLine())
			{
				if(nextLine.startsWith("TET_ROOT"))
				{
					int i = nextLine.indexOf("=");
					tet_root = nextLine.substring(i+1);
					int j = tet_root.length();
					tet_root = tet_root.substring(0,j);
				}
			}
		}
		return tet_root;
	}
	
//---------load image--------------------------------------------------------------------
	
	Image getImage(String filename)
	{
		Toolkit tk = getToolkit();
		return tk.getImage(filename);
	}


//---------No test suite selected Dialog-------------------------------------------------

	class NoTSuiteDialog extends Dialog
	{
		public NoTSuiteDialog(Frame parent)
		{
			super(parent, "No test suite selected", true);
			Panel p1 = new Panel();
			p1.add(new Label("No test suite has been selected."));
			p1.add(new Label("Open a scenarioFile by selecting"));
			p1.add(new Label("'File | Open Test Suite'"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(200,150);
		}

//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------
	
		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------Alternate Scenario Dialog------------------------------------------------------------------

	class AlternateScenarioDialog extends Dialog
	{
		public AlternateScenarioDialog(Frame parent)
		{
			super(parent, "Alternate Scenario File", true);
			Panel p1 = new Panel();
			p1.add(new Label("You have chosen " + scenarioFile + " as your scenarioFile file"));
			p1.add(new Label("This is not the default, 'tet_scen'."));
			p1.add(new Label("Are you sure you want to use " + scenarioFile + " as your scenario file?"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("Yes"));
			p2.add(new Button("No"));
			add("South",p2);
			setSize(450,200);
		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("Yes"))
			{
				try
				{
					FileOutputStream fos = new FileOutputStream("ScenF");
					PrintStream ps = new PrintStream(fos);
					ps.print("-s " + testSuite + scenarioFile + " **! \n");
					fos.close();
				}
				catch(IOException e)
				{
					System.out.println("Problems writing to file ScenF");
				}

				setFile = true;
				dispose();
				return true;
			}

			if(arg.equals("No"))
			{
				setFile = false;
				dispose();
				return true;
			}

			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------Incorrect timeout value Dialog------------------------------------------------------------------

	class TimeoutDialog extends Dialog
	{
		public TimeoutDialog(Frame parent)
		{
			super(parent, "Error", true);
			Panel p1 = new Panel();
			p1.add(new Label("The timeout value is not in the correct format."));
			p1.add(new Label("Please enter an integer timeout value."));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(300,150);
		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}

			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------About Dialog------------------------------------------------------------------

	class AboutDialog extends Dialog
	{
		public AboutDialog(Frame parent)
		{
			super(parent, "About TETWare", true);
			Panel p1 = new Panel();
			p1.add(new Label("TETware GUI"));
			p1.add(new Label("Designed and implemented by"));
			p1.add(new Label("Joanna Plumpton 1998"));
			p1.add(new Label("Southampton University"));

			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(200,150);
		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------Help Dialog------------------------------------------------------------------

	class HelpDialog extends Dialog
	{
		public HelpDialog(Frame parent)
		{
			super(parent, "TETWare Help", true);
			Panel p1 = new Panel();
			p1.add(new Label("For help concerning TETware:"));
			p1.add(new Label("Please read the manual."));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(200,150);
		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------Exception Dialog - error with test scenarioFile-----------------------------------

	class ExceptionDialog extends Dialog
	{
		public ExceptionDialog(Frame parent)
		{
			super(parent, "Error", true);
			Panel p1 = new Panel();
			p1.add(new Label("There is an error with " + scenarioFile));
			p1.add(new Label("Please read the stderr for advice."));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(300,150);
		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------No old journal Dialog - error with test scenarioFile-----------------------------------

	class NoOldJournalDialog extends Dialog
	{
		public NoOldJournalDialog(Frame parent)
		{
			super(parent, "Error", true);
			Panel p1 = new Panel();
			p1.add(new Label("No old journal file has been specified"));
			p1.add(new Label("Choose an old journal file by selecting:"));
			p1.add(new Label("\'Options | Advanced Options | Old Journal File\'"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);

			setSize(300,150);
		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------View Formatted Journal File Dialog--------------------------------------------

	class ViewJFDialog extends Dialog
	{
		private TextArea textAreaJF;

		public ViewJFDialog(Frame parent)
		{
			super(parent, "View Journal File", true);

			setLayout(new BorderLayout());
			Panel n = new Panel();
			add("North",n);
			Panel e = new Panel();
			add("East",e);
			Panel c = new Panel();
			add("Center",c);
			Panel s = new Panel();
			add("South",s);

			n.add(new Label("Please enter path of journal file:"));
			textFieldJF = new TextField(42);
			c.add(textFieldJF);
			Button browse = new Button("Browse");
			e.add("East", browse);
			Button view = new Button("View");
			s.add(view);
			Button cancel = new Button("Cancel");
			s.add(cancel);
			setSize(400,150);
		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
			frBounds = bounds;
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("Browse"))
			{
				FileDialog od = new FileDialog(new Tetv3_gui(), "Open Journal file", FileDialog.LOAD);
				od.show();
				if(od.getFile()!=null)
					textFieldJF.setText(od.getDirectory() + od.getFile());
			}			

			if(arg.equals("View"))
			{
				boolean fileExist;
				String dir="";
				String jFiles = textFieldJF.getText();
				int flag = 0;
				if(jFiles.endsWith("\n"))
					jFiles = jFiles.substring(0,jFiles.lastIndexOf("\n"));
				if(jFiles.compareTo("")==0)
				{
					NoJournalDialog njd = new NoJournalDialog(new Tetv3_gui(),1);
					njd.show();
					return true;
				}
				int index = jFiles.length() - 1;
				dir = jFiles.substring(0,index);
				int tmpI=dir.lastIndexOf("\\"); //in win95/NT
				if(tmpI == -1)
					tmpI=dir.lastIndexOf("/");	//in Linux
				if(tmpI != -1)
					dir = dir.substring(0, tmpI);
				System.out.println(dir + " is dir");
				String rptName = "formatted";
				String rptmName = "compared";
				File rptfile;
				int count=0;
				osys = System.getProperty("os.name");
				Process jpad;
				fileExist = (new File(dir,rptName)).exists();
				rptfile = new File(dir, rptName);
				if(fileExist == true)
				{
					try
					{
						if(osys.compareTo("Windows 95") == 0 || osys.compareTo("Windows NT") == 0)						
							jpad = Runtime.getRuntime().exec("java JavaPad " + "\"" + rptfile + "\"");
						else
							jpad = Runtime.getRuntime().exec("java JavaPad " + rptfile);
						return true;
					}
					catch(IOException e)
					{
						System.out.println("JavaPad problems " + e);
					}
				}

				try{
					FileOutputStream fos = new FileOutputStream(rptfile);
					PrintStream ps = new PrintStream(fos);
					Process proc;
					proc = Runtime.getRuntime().exec("rpt -f " + jFiles);
					BufferedReader is = new BufferedReader(new InputStreamReader(proc.getInputStream()));
					for(String nextline=is.readLine(); nextline != null; nextline = is.readLine())
					{
						//System.out.println(nextline);
						nextline+="\n";
						ps.print(nextline);
						//textArea1.append(nextline);
					}
					if(osys.compareTo("Windows 95") == 0 || osys.compareTo("Windows NT") == 0)						
						jpad = Runtime.getRuntime().exec("java JavaPad " + "\"" + rptfile + "\"");
					else
						jpad = Runtime.getRuntime().exec("java JavaPad " + rptfile);
				}
				catch(IOException e)
				{
					System.out.println("Problem with rpt command " + e);
				}
			
				dispose();
				return true;
			}


			if(arg.equals("Cancel"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------Compare Test Results Dialog--------------------------------------------

	class CompareResultsDialog extends Dialog
	{
		private TextArea textAreaJF;

		public CompareResultsDialog(Frame parent)
		{
			super(parent, "Compare Test Results", true);

			setLayout(new BorderLayout());
			Panel n = new Panel();
			add("North",n);
			Panel e = new Panel();
			add("East",e);
			Panel c = new Panel();
			add("Center",c);
			Panel s = new Panel();
			add("South",s);

			n.add(new Label("Please enter the path of each journal file on a separate line:"));
			textAreaJF = new TextArea(4,42);
			c.add(textAreaJF);
			Button browse = new Button("Browse");
			e.add("East", browse);
			Button view = new Button("View");
			s.add(view);
			Button cancel = new Button("Cancel");
			s.add(cancel);
			setSize(400,200);
		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
			frBounds = bounds;
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("Browse"))
			{
				FileDialog od = new FileDialog(new Tetv3_gui(), "Open Journal file", FileDialog.LOAD);
				od.show();
				if(od.getFile()!=null)
					textAreaJF.append(od.getDirectory() + od.getFile() + "\n");
			}			

			if(arg.equals("View"))
			{
				boolean fileExist;
				String dir="";
				String jFiles = textAreaJF.getText();
				String tmp = "";
				int flag = 0;
				if(jFiles.endsWith("\n"))
					jFiles = jFiles.substring(0,jFiles.lastIndexOf("\n"));
				if(jFiles.compareTo("")==0)
				{
					NoJournalDialog njd = new NoJournalDialog(new Tetv3_gui(),1);
					njd.show();
					return true;
				}
				while(jFiles.compareTo("")!=0)
				{
					while(jFiles.indexOf("\n") != -1)
					{
						tmp+= jFiles.substring(0, jFiles.indexOf("\n")) + " ";
						jFiles = jFiles.substring(jFiles.indexOf("\n") +1);
					}
					tmp += jFiles;
					tmp = tmp.trim();
					jFiles = "";
					if(tmp.indexOf(" ")!=-1)
						flag=1;
				}
				int index = tmp.indexOf(" ");
				if(index == -1)
					index = tmp.length() - 1;
				dir = tmp.substring(0,index);
				int tmpI=dir.lastIndexOf("\\"); //in win95/NT
				if(tmpI == -1)
					tmpI=dir.lastIndexOf("/");	//in Linux
				if(tmpI != -1)
					dir = dir.substring(0, tmpI);
				System.out.println(dir + " is dir");
				String rptmName = "compared";
				File rptfile;
				int count=0;
				osys = System.getProperty("os.name");
				Process jpad;
				fileExist = (new File(dir,rptmName)).exists();
				while(fileExist==true)
				{
					count++;
					rptmName = "compared" + count;
					fileExist = (new File(dir,rptmName)).exists();
				}
				rptfile = new File(dir, rptmName);

				try{
					FileOutputStream fos = new FileOutputStream(rptfile);
					PrintStream ps = new PrintStream(fos);
					Process proc;
					if(flag == 0)
					{
						
						NoJournalDialog njd = new NoJournalDialog(new Tetv3_gui(), "rptm");
						njd.show();
						return true;

					}else{
						proc = Runtime.getRuntime().exec("rptm -f " + tmp);

					}
					BufferedReader is = new BufferedReader(new InputStreamReader(proc.getInputStream()));
					for(String nextline=is.readLine(); nextline != null; nextline = is.readLine())
					{
						//System.out.println(nextline);
						nextline+="\n";
						ps.print(nextline);
						//textArea1.append(nextline);
					}
					if(osys.compareTo("Windows 95") == 0 || osys.compareTo("Windows NT") == 0)						
						jpad = Runtime.getRuntime().exec("java JavaPad " + "\"" + rptfile + "\"");
					else
						jpad = Runtime.getRuntime().exec("java JavaPad " + rptfile);
				}
				catch(IOException e)
				{
					System.out.println("Problem with rptm command " + e);
				}
			
				dispose();
				return true;
			}


			if(arg.equals("Cancel"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------No journal file selected to format--------------------------------------------

	class NoJournalDialog extends Dialog
	{
		public NoJournalDialog(Frame parent, int i)
		{
			super(parent, "Error", true);
			Panel p1 = new Panel();
			p1.add(new Label("No journal file has been specified"));
			p1.add(new Label("Choose a journal file by:"));
			p1.add(new Label("using the 'Browse' button or typing the path"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(300,150);
		}
	
		public NoJournalDialog(Frame parent, String s)
		{
			super(parent, "Error", true);
			Panel p1 = new Panel();
			p1.add(new Label("Only one journal file has been specified."));
			p1.add(new Label("At least two journal files must be compared."));
			p1.add(new Label("Choose another journal file by:"));
			p1.add(new Label("using the 'Browse' button or typing the path"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(300,200);
		}

//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle dgBounds = bounds();
			move(frBounds.x + (frBounds.width - dgBounds.width)/ 2,
				 frBounds.y + (frBounds.height - dgBounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------Exit Dialog------------------------------------------------------------------

	class ExitDialog extends Dialog
	{
		public ExitDialog(Frame parent)
		{
			super(parent, "Exit?", true);
			Panel p1 = new Panel();
			p1.add(new Label("Are you sure you"));
			p1.add(new Label("want to quit?"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("Yes"));
			p2.add(new Button("No"));
			add("South",p2);
			setSize(200,150);
		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle bounds = getParent().bounds();
			Rectangle abounds = bounds();
	
			move(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("Yes"))
			{
				scenario = textFieldS.getText().trim();
				System.out.println("the testsuite is " + testSuite);
				System.out.println("the scenarioFile is " + scenarioFile);
				System.out.println("the scenario is " + scenario);
				String TSop = "";
				if(testSuite.compareTo("")>0)
				{
					TSop += "-ts " + testSuite + " ** ";
					TSop += "-sf " + scenarioFile + " ** ";
					if(scenario.compareTo("")>0)
						TSop += "-ss " + scenario + " **";
				}
				TSop+="\n";
				try
				{
					FileOutputStream fos = new FileOutputStream("TSop");
					PrintStream ps = new PrintStream(fos);
					if(TSop.compareTo("")==0)
						System.out.println("TSop is empty");
					ps.print(TSop);
					fos.close();
				}
				catch(IOException e)
				{
					System.out.println("Problems writing to file AdvOp");
				}

				dispose();
				System.exit(0);
				return super.handleEvent(evt);
			}
			if(arg.equals("No"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}


//---------components--------------------------------------------------------------------

	Button button1;
	Button buttonC;
	Button buttonOTS;
	Button buttonCAO;
	Button buttonVJ;
	Checkbox checkbox1;
	Checkbox checkbox2;
	Checkbox checkbox3;
	Checkbox checkboxS;
//	Checkbox checkboxPR;
	TextArea textArea1;
	TextField textField1;
	TextField textField2;
	TextField textFieldTS;
	TextField textFieldSF;
	TextField textFieldS;
	TextField textFieldJF;
	Label labelT;
	Label labelin;
	Label labelout;

//---------Menu Items--------------------------------------------------------------------

	MenuBar mainMenuBar;
	Menu menu1;
	MenuItem miNew;
	MenuItem miOpen;
	MenuItem miClose;
	MenuItem miExit;
	Menu menu2;
	MenuItem miViewRJF;
	MenuItem miViewJF;
	MenuItem miOpenPad;
	MenuItem miCompare;
	Menu menu3;
	MenuItem miRun;
	MenuItem miAdvOptions;
	CheckboxMenuItem miProgRep;
	Menu menu4;
	MenuItem miTetHelp;
	MenuItem miAbout;


//---------Global variables--------------------------------------------------------------

	String title = "TETware 3 GUI (Version 0.5) ";
	String scenarioFile = "";
	String testSuite = "";
	String scenario = "";
	String cmd = "tcc ";
	String args = "";
	boolean cb1Flag = false;
	boolean cb2Flag = false;
	boolean cb3Flag = false;
	boolean setFile = true;
	String advop = "";
	String osys;

	String strM = "";
	String strR = "";
	String strOJF = "";
	String strS = "";
	String strJ = "";
	String strG = "";
	String strX = "";
	String strF = "";
	String strA = "";
	String strI = "";
	String strL = "";
	String strN = "";
	String strY = "";
	String strV = "";

	Rectangle frBounds;
}
